package com.ibm.mqe.bridgemodel;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.mqe.mqbridge.*;
import com.ibm.uia.metamodel.*;
import com.ibm.uia.renderingInterface.*;
import com.ibm.uia.xml.*;
import com.ibm.mqe.model.*;
import com.ibm.mqe.*;
import java.util.*;
/**
 * Insert the type's description here.
 * Creation date: (12/07/2000 13:05:30)
 * @author: Phill van Leersum
 */
public class MQeBridgeProxy extends AbstractBridgeObject {
	private static final String CMD_CREATE_BRIDGEQM = "QueueManager";
/**
 * adminMessage method comment.
 */
private MQeMQBridgeAdminMsg bridgeAdminMessage() {
	try {
		return new MQeMQBridgeAdminMsg(getName(), false);
	} catch (Exception e) {
		_warning("error creating bridge admin message", e);
	}
	return null;
}
/**
 * adminMessage method comment.
 */
protected MQeMQBridgesAdminMsg bridgeTypeAdminMessage() {
	return bridgeAdminMessage();
}
private boolean createBridgeQM(Renderer renderer, String[] data) {
	boolean changed = false;
	if (null != data) {
		String bridgeName = data[0];
		String type = BRIDGE_QM_TYPE_NAME;
		UIObject uio = findExistingChild(type, bridgeName);
		if (null == uio) {
			uio = addNewChild(type, bridgeName);
		}
		if (null != uio) {
			uio.setAttribute(QMHOSTNAME_ATTRIBUTE, data[1]);
			((MQeObject)uio).commit(false);
		}
		changed = true;
	}
	return changed;
}
protected String getChildTypeName() {
	return BRIDGE_QM_TYPE_NAME;
}
/**
 * Perform the actions represented by the supplied instance of 
 * <code>RenderableOperation</code> defined in te metamodel file.
 * If the operation was defined with a prompt then the String array
 * will be non-null, and will contain a string for every line of the prompt
 *
 * The renderer responsible for delivering the operation request is passed in
 * for convenience.
 *
 * Reply true if a stuctural refresh is required.
 */
public boolean performOperation(RenderableOperation op, Renderer renderer) {
	String[] data = op.getData();
	String command = op.getName();
	boolean reply = false;
	if (CMD_CREATE_BRIDGEQM.equals(command)) {
		reply = createBridgeQM(renderer, data);
	} else {
		reply = super.performOperation(op, renderer);
	}
	return reply;
}
}
