package com.ibm.mqe.model;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.metamodel.*;
/**
 * This type represents an entity that has very little behaviour
 * and no children.  Its behaviour is controlled almost entirely
 * by its parent.
 * This type represents all Alii ('aliases'), and QueueManager 
 * entries in StoreAndForwardQueues.
 * Creation date: (02/07/2000 14:02:03)
 * @author: Phill van Leersum
 */
public final class ConnectionAdaptor extends CreatableObject {
/**
 * Read the receivers attributes from the 
 * output data field
 * Overridden here, as we know the state can change from
 * creating to created
 */
protected boolean _readAttributes(com.ibm.mqe.MQeFields data) {
	boolean reply = super._readAttributes(data);
	if (isToBeCreated() || isCreating()) {
		setStateCreated();
	}
	return reply;
}
protected Connection _realParent() {
	UIObject parent = getParent();
	while (null != parent) {
		if (parent instanceof Connection) {
			return (Connection)parent;
		}
		parent = parent.getParent();
	}
	return null;
}
protected boolean performCreate() {
	super.performCreate();
	ManagedObject mop = _realParent();
	if (null != mop) {
		mop._reallyCreateAlias(getName());
	}
	return true;
}
protected boolean performDelete() {
	super.performDelete();
	ManagedObject mop = _realParent();
	if (null != mop) {
		mop._reallyDeleteAlias(getName());
	}
	return true;
}
}
