package com.ibm.mqe.model;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.metamodel.*;
import com.ibm.mqe.*;
import java.util.*;

/**
 * This type represents an entity that has very little behaviour
 * and no children.  Its behaviour is controlled almost entirely
 * by its parent.
 * This type represents all Alii ('aliases'), and QueueManager 
 * entries in StoreAndForwardQueues.
 * Creation date: (02/07/2000 14:02:03)
 * @author: Phill van Leersum
 */
public final class MQeFieldsObject extends CreatableObject {
	MQeFields mqeFields;
protected ManagedObject _realParent() {
	UIObject parent = getParent();
	while (null != parent) {
		if (parent instanceof ManagedObject) {
			return (ManagedObject)parent;
		}
		parent = parent.getParent();
	}
	return null;
}
protected boolean performDelete() {
	ManagedObject mop = _realParent();
	if (null != mop) {
		if (mop instanceof AbstractQueue) {
			if (((AbstractQueue) mop).deleteMessage(mqeFields)) {
				super.performDelete();
				getParent().removeChild(this);
			}
		}
	}
	return true;
}
void setFields(MQeFields  f) {
	mqeFields = f;
	Enumeration enum = mqeFields.fields();
	while (enum.hasMoreElements()) {
		try {
			String fieldName = enum.nextElement().toString();
			if (MQeField.TypeFields == mqeFields.dataType(fieldName)) {
				String displayFieldName = getMetaObject().mapValue(fieldName);
				MQeFieldsObject fo = (MQeFieldsObject)addNewChild(MESSAGEFIELDS_TYPE_NAME, displayFieldName);
				fo.setFields(mqeFields.getFields(fieldName));
			} else {
				String displayFieldName = getMetaObject().mapValue(fieldName);
				MQeFieldObject fo = (MQeFieldObject)addNewChild(MESSAGEFIELD_TYPE_NAME, displayFieldName);
				fo.setAttribute("value", mqeFields.dumpToString("#2", fieldName));
				fo.setAttribute("type", mqeFields.dumpToString("#0", fieldName));
			}
		} catch (Exception e) {
		}
	}
}
}
