package com.ibm.mqe.model;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.mqe.*;
import com.ibm.uia.metamodel.*;
import com.ibm.uia.renderingInterface.*;
/**
 * This type represents an entity that has very little behaviour
 * and no children.  Its behaviour is controlled almost entirely
 * by its parent.
 * This type represents all Alii ('aliases'), and QueueManager 
 * entries in StoreAndForwardQueues.
 * Creation date: (02/07/2000 14:02:03)
 * @author: Phill van Leersum
 */
public final class MessageCategory extends CreatableObject {
	private static final String CMD_BROWSE_MESSAGES = "Refresh Messages";
/**
 * MQeDumbObject constructor comment.
 * @param name java.lang.String
 * @param metaObject com.ibm.uia.metamodel.MetaObject
 */
public MessageCategory() {
	super();
}
protected AbstractQueue _parentQueue() {
	UIObject parent = getParent();
	while (null != parent) {
		if (parent instanceof AbstractQueue) {
			return (AbstractQueue)parent;
		}
		parent = parent.getParent();
	}
	return null;
}
protected ManagedObject _realParent() {
	UIObject parent = getParent();
	while (null != parent) {
		if (parent instanceof ManagedObject) {
			return (ManagedObject)parent;
		}
		parent = parent.getParent();
	}
	return null;
}
/**
 * Perform the actions represented by the supplied instance of 
 * <code>RenderableOperation</code> defined in te metamodel file.
 * If the operation was defined with a prompt then the String array
 * will be non-null, and will contain a string for every line of the prompt
 *
 * The renderer responsible for delivering the operation request is passed in
 * for convenience.
 *
 * Reply true if a stuctural refresh is required.
 */
public boolean performOperation(RenderableOperation op, Renderer renderer) {
	String[] data = op.getData();
	String command = op.getName();
	boolean reply = false;
	if (CMD_BROWSE_MESSAGES.equals(command)) {
		removeAllChildren(MESSAGE_TYPE_NAME);	
		MQeEnumeration enum = _parentQueue().browse();
		while (enum.hasMoreElements()) {
			MQeMsgObject msg = (MQeMsgObject)enum.nextElement();
			try {
				long l = msg.getTimeStamp();
				String msgName = msg.getOriginQMgr() + "/" + Long.toString(l);
				MQeFieldsObject fo = (MQeFieldsObject)addNewChild(MESSAGE_TYPE_NAME, msgName);
				fo.setFields(msg);
				fo.setStateCreated();
			} catch (Exception e) {
			}
		}
		reply = true;
	} else {
		reply = super.performOperation(op, renderer);
	}
	return reply;
}
}
