package com.ibm.mqe.model;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.metamodel.*;
import com.ibm.uia.renderingInterface.*;
/**
 * This type represents an entity that has very little behaviour
 * and no children.  Its behaviour is controlled almost entirely
 * by its parent.
 * This type represents all Alii ('aliases'), and QueueManager 
 * entries in StoreAndForwardQueues.
 * Creation date: (02/07/2000 14:02:03)
 * @author: Phill van Leersum
 */
public final class QueueManagerEntry extends CreatableObject {
protected StoreAndForwardQueue _realParent() {
	UIObject parent = getParent();
	while (null != parent) {
		if (parent instanceof StoreAndForwardQueue) {
			return (StoreAndForwardQueue)parent;
		}
		parent = parent.getParent();
	}
	return null;
}
protected boolean performCreate() {
	super.performCreate();
	ManagedObject mop = _realParent();
	if (null != mop) {
		((StoreAndForwardQueue) mop)._reallyAddQueueManager(getName());
	}
	return true;
}
protected boolean performDelete() {
	super.performDelete();
	ManagedObject mop = _realParent();
	if (null != mop) {
		((StoreAndForwardQueue)mop)._reallyDeleteQmEntry(getName());
	}
	return true;
}
/**
 * Perform the actions represented by the supplied instance of 
 * <code>RenderableOperation</code> defined in te metamodel file.
 * If the operation was defined with a prompt then the String array
 * will be non-null, and will contain a string for every line of the prompt
 *
 * The renderer responsible for delivering the operation request is passed in
 * for convenience.
 *
 * Reply true if a stuctural refresh is required.
 */
public boolean performOperation(RenderableOperation op, Renderer renderer) {
	String[] data = op.getData();
	String command = op.getName();
	boolean reply = false;
	if ("Test Message".equals(command)) {
		performTestMessage(renderer);
	} else {
		reply = super.performOperation(op, renderer);
	}
	return reply;
}
/**
 * Perform the placing of a tespt message.
 */
public boolean performTestMessage(Renderer renderer) {
	String[] data = renderer.promptUserForStrings("Enter TestMessage Data for " + getName(), 
		new String[] {"Queue Name", "text"}, 
		new String[] {"SYSTEM.DEFAULT.LOCAL.QUEUE", "Test Data"});
	if (null != data && data.length > 1) {
		_realParent().testMessage(getName(), data[0], data[1]);
	}
	return false;
}
}
