package com.ibm.uia.renderer;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.renderingInterface.*;
import java.awt.*;
import java.awt.event.*;
/**
 * This type implements a renderable operation rendered as a menu item.
 * It is created for a particular renderable operation and renderer.
 * @Author: Phill van Leersum
 */
class OperationsMenuItem extends MenuItem implements ActionListener {
	private RenderableOperation rop;
	private Renderer renderer;
/**
 * LinkedMenuItem constructor comment.
 * @param label java.lang.String
 */
public OperationsMenuItem(RenderableOperation rop, Renderer renderer) {
	super(rop.getCaptionText());
	this.rop = rop;
	this.renderer = renderer;
	setEnabled(rop.isEnabled());
	//enableEvents(-1L /*AWTEvent.ACTION_EVENT_MASK*/);
	addActionListener( this);
}
public void actionPerformed(ActionEvent e) {
	if (rop.perform(renderer)) {
		renderer.redisplay(true);
	}
}
final RenderableOperation getRenderableOperation() {
	return rop;
}
}
